/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 13 "./mvl_scomp_y.y" /* yacc.c:339  */

#include <stdio.h>
#include <string.h>
#include "mut.h"
#include "mlo.h"
#include "mvl_stype.h"
#include "mvl_syacc.h"
#include "mvl_stdef.h"
#include "gen_generic.h"


extern int           yylex      ();
extern void          yyerror    ();

static int           MVL_CONRNK = 0   ; /* rank of an implicit connexion*/
static int           MVL_SIGIDX = 1   ; /* structural's signal index    */
static int           MVL_SIMFLG = 0   ; /* simple flag                  */
static int           MVL_CONCNT = 0   ; /* connector's count            */
static char         *MVL_MODNAM ;       /* current model name           */
static char         *MVL_CHDNAM ;       /* child's model name           */
static char         *MVL_LOCNAM ;       /* instance's name              */
static struct chain *MVL_NM1LST = NULL; /* 1-st name liste              */
static struct chain *MVL_NM2LST = NULL; /* 2-nd name liste              */
static struct lofig *MVL_CHDPNT = NULL; /* current child pointer        */
static struct lofig *MVL_CHDHED = NULL; /* childs list                  */
static struct ptype *MVL_PTPPNT = NULL;
static struct chain *MVL_GENLST = NULL;
static struct logen *MVL_GENPNT = NULL;
static struct logen  MVL_LOGEN;
static long              base ;


#line 99 "y.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    Ampersand = 258,
    Apostrophe = 259,
    LeftParen = 260,
    RightParen = 261,
    DoubleStar = 262,
    Star = 263,
    Plus = 264,
    Comma = 265,
    Minus = 266,
    VarAsgn = 267,
    Colon = 268,
    Semicolon = 269,
    _LESym = 270,
    Box = 271,
    _LTSym = 272,
    Arrow = 273,
    _EQSym = 274,
    _GESym = 275,
    _GTSym = 276,
    Bar = 277,
    _NESym = 278,
    Dot = 279,
    Slash = 280,
    Identifier = 281,
    DecimalInt = 282,
    DecimalReal = 283,
    AbstractLit = 284,
    BasedInt = 285,
    BasedReal = 286,
    CharacterLit = 287,
    StringLit = 288,
    BitStringLit = 289,
    ABS = 290,
    ACCESS = 291,
    AFTER = 292,
    ALIAS = 293,
    ALL = 294,
    tok_AND = 295,
    ARCHITECTURE = 296,
    ARRAY = 297,
    ARG = 298,
    ASSERT = 299,
    ATTRIBUTE = 300,
    _BEGIN = 301,
    BIT = 302,
    BIT_VECTOR = 303,
    BLOCK = 304,
    BODY = 305,
    BUFFER = 306,
    BUS = 307,
    CASE = 308,
    CLOCK = 309,
    COMPONENT = 310,
    CONFIGURATION = 311,
    CONSTANT = 312,
    CONVERT = 313,
    DISCONNECT = 314,
    DOWNTO = 315,
    ELSE = 316,
    ELSIF = 317,
    _END = 318,
    ENTITY = 319,
    ERROR = 320,
    _EXIT = 321,
    _FILE = 322,
    FOR = 323,
    FUNCTION = 324,
    GENERATE = 325,
    GENERIC = 326,
    GUARDED = 327,
    IF = 328,
    _IN = 329,
    _INOUT = 330,
    INTEGER = 331,
    IS = 332,
    _LABEL = 333,
    LIBRARY = 334,
    _LINKAGE = 335,
    _LIST = 336,
    LOOP = 337,
    MAP = 338,
    MOD = 339,
    MUX_BIT = 340,
    MUX_VECTOR = 341,
    _NAND = 342,
    NATURAL = 343,
    NATURAL_VECTOR = 344,
    NEW = 345,
    _NEXT = 346,
    _NOR = 347,
    _NOT = 348,
    tok_NULL = 349,
    OF = 350,
    ON = 351,
    OPEN = 352,
    _OR = 353,
    OTHERS = 354,
    _OUT = 355,
    _PACKAGE = 356,
    PORT = 357,
    POSITIVE = 358,
    PROCEDURE = 359,
    PROCESS = 360,
    RANGE = 361,
    RECORD = 362,
    REG_BIT = 363,
    REG_VECTOR = 364,
    REGISTER = 365,
    REM = 366,
    REPORT = 367,
    RETURN = 368,
    SELECT = 369,
    SEVERITY = 370,
    SIGNAL = 371,
    _STABLE = 372,
    STRING = 373,
    SUBTYPE = 374,
    THEN = 375,
    TO = 376,
    TRANSPORT = 377,
    _TYPE = 378,
    UNITS = 379,
    UNTIL = 380,
    USE = 381,
    VARIABLE = 382,
    WAIT = 383,
    WARNING = 384,
    WHEN = 385,
    WHILE = 386,
    WITH = 387,
    WOR_BIT = 388,
    WOR_VECTOR = 389,
    _XOR = 390
  };
#endif
/* Tokens.  */
#define Ampersand 258
#define Apostrophe 259
#define LeftParen 260
#define RightParen 261
#define DoubleStar 262
#define Star 263
#define Plus 264
#define Comma 265
#define Minus 266
#define VarAsgn 267
#define Colon 268
#define Semicolon 269
#define _LESym 270
#define Box 271
#define _LTSym 272
#define Arrow 273
#define _EQSym 274
#define _GESym 275
#define _GTSym 276
#define Bar 277
#define _NESym 278
#define Dot 279
#define Slash 280
#define Identifier 281
#define DecimalInt 282
#define DecimalReal 283
#define AbstractLit 284
#define BasedInt 285
#define BasedReal 286
#define CharacterLit 287
#define StringLit 288
#define BitStringLit 289
#define ABS 290
#define ACCESS 291
#define AFTER 292
#define ALIAS 293
#define ALL 294
#define tok_AND 295
#define ARCHITECTURE 296
#define ARRAY 297
#define ARG 298
#define ASSERT 299
#define ATTRIBUTE 300
#define _BEGIN 301
#define BIT 302
#define BIT_VECTOR 303
#define BLOCK 304
#define BODY 305
#define BUFFER 306
#define BUS 307
#define CASE 308
#define CLOCK 309
#define COMPONENT 310
#define CONFIGURATION 311
#define CONSTANT 312
#define CONVERT 313
#define DISCONNECT 314
#define DOWNTO 315
#define ELSE 316
#define ELSIF 317
#define _END 318
#define ENTITY 319
#define ERROR 320
#define _EXIT 321
#define _FILE 322
#define FOR 323
#define FUNCTION 324
#define GENERATE 325
#define GENERIC 326
#define GUARDED 327
#define IF 328
#define _IN 329
#define _INOUT 330
#define INTEGER 331
#define IS 332
#define _LABEL 333
#define LIBRARY 334
#define _LINKAGE 335
#define _LIST 336
#define LOOP 337
#define MAP 338
#define MOD 339
#define MUX_BIT 340
#define MUX_VECTOR 341
#define _NAND 342
#define NATURAL 343
#define NATURAL_VECTOR 344
#define NEW 345
#define _NEXT 346
#define _NOR 347
#define _NOT 348
#define tok_NULL 349
#define OF 350
#define ON 351
#define OPEN 352
#define _OR 353
#define OTHERS 354
#define _OUT 355
#define _PACKAGE 356
#define PORT 357
#define POSITIVE 358
#define PROCEDURE 359
#define PROCESS 360
#define RANGE 361
#define RECORD 362
#define REG_BIT 363
#define REG_VECTOR 364
#define REGISTER 365
#define REM 366
#define REPORT 367
#define RETURN 368
#define SELECT 369
#define SEVERITY 370
#define SIGNAL 371
#define _STABLE 372
#define STRING 373
#define SUBTYPE 374
#define THEN 375
#define TO 376
#define TRANSPORT 377
#define _TYPE 378
#define UNITS 379
#define UNTIL 380
#define USE 381
#define VARIABLE 382
#define WAIT 383
#define WARNING 384
#define WHEN 385
#define WHILE 386
#define WITH 387
#define WOR_BIT 388
#define WOR_VECTOR 389
#define _XOR 390

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 46 "./mvl_scomp_y.y" /* yacc.c:355  */

  long         valu;
  char       *text;
  char        flag;
  mvl_name    name;
  mvl_expr    expr;
  

#line 418 "y.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 435 "y.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  8
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   225

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  136
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  95
/* YYNRULES -- Number of rules.  */
#define YYNRULES  159
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  250

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   390

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   223,   223,   235,   232,   259,   264,   266,   271,   270,
     284,   290,   294,   296,   302,   334,   338,   344,   349,   354,
     361,   380,   382,   386,   388,   392,   397,   404,   408,   410,
     416,   547,   566,   574,   565,   588,   594,   597,   599,   604,
     605,   606,   612,   699,   697,   730,   732,   740,   744,   746,
     752,   859,   877,   880,   882,   887,   888,   896,   894,  1002,
    1005,  1009,  1021,  1025,  1027,  1033,  1040,  1045,  1049,  1053,
    1057,  1061,  1067,  1065,  1080,  1081,  1082,  1086,  1089,  1097,
    1101,  1106,  1107,  1117,  1116,  1125,  1127,  1133,  1142,  1153,
    1157,  1165,  1170,  1181,  1183,  1187,  1195,  1199,  1201,  1207,
    1262,  1326,  1345,  1368,  1373,  1379,  1381,  1386,  1398,  1409,
    1414,  1419,  1424,  1426,  1444,  1450,  1455,  1457,  1459,  1562,
    1569,  1577,  1579,  1584,  1585,  1587,  1589,  1591,  1600,  1601,
    1603,  1605,  1607,  1612,  1614,  1616,  1618,  1620,  1622,  1624,
    1626,  1628,  1630,  1632,  1634,  1636,  1642,  1643,  1649,  1648,
    1655,  1657,  1666,  1673,  1674,  1679,  1684,  1689,  1702,  1707
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "Ampersand", "Apostrophe", "LeftParen",
  "RightParen", "DoubleStar", "Star", "Plus", "Comma", "Minus", "VarAsgn",
  "Colon", "Semicolon", "_LESym", "Box", "_LTSym", "Arrow", "_EQSym",
  "_GESym", "_GTSym", "Bar", "_NESym", "Dot", "Slash", "Identifier",
  "DecimalInt", "DecimalReal", "AbstractLit", "BasedInt", "BasedReal",
  "CharacterLit", "StringLit", "BitStringLit", "ABS", "ACCESS", "AFTER",
  "ALIAS", "ALL", "tok_AND", "ARCHITECTURE", "ARRAY", "ARG", "ASSERT",
  "ATTRIBUTE", "_BEGIN", "BIT", "BIT_VECTOR", "BLOCK", "BODY", "BUFFER",
  "BUS", "CASE", "CLOCK", "COMPONENT", "CONFIGURATION", "CONSTANT",
  "CONVERT", "DISCONNECT", "DOWNTO", "ELSE", "ELSIF", "_END", "ENTITY",
  "ERROR", "_EXIT", "_FILE", "FOR", "FUNCTION", "GENERATE", "GENERIC",
  "GUARDED", "IF", "_IN", "_INOUT", "INTEGER", "IS", "_LABEL", "LIBRARY",
  "_LINKAGE", "_LIST", "LOOP", "MAP", "MOD", "MUX_BIT", "MUX_VECTOR",
  "_NAND", "NATURAL", "NATURAL_VECTOR", "NEW", "_NEXT", "_NOR", "_NOT",
  "tok_NULL", "OF", "ON", "OPEN", "_OR", "OTHERS", "_OUT", "_PACKAGE",
  "PORT", "POSITIVE", "PROCEDURE", "PROCESS", "RANGE", "RECORD", "REG_BIT",
  "REG_VECTOR", "REGISTER", "REM", "REPORT", "RETURN", "SELECT",
  "SEVERITY", "SIGNAL", "_STABLE", "STRING", "SUBTYPE", "THEN", "TO",
  "TRANSPORT", "_TYPE", "UNITS", "UNTIL", "USE", "VARIABLE", "WAIT",
  "WARNING", "WHEN", "WHILE", "WITH", "WOR_BIT", "WOR_VECTOR", "_XOR",
  "$accept", "design_file", "entity_declaration", "$@1",
  ".generic_clause.", "generic_clause", "$@2", "formal_generic_list",
  "...formal_generic_element..", "formal_generic_element",
  "generic_VarAsgn__expression", ".constraint.", "constraint", "range",
  "direction", ".port_clause.", "port_clause", "formal_port_list",
  "...formal_port_element..", "formal_port_element", "architecture_body",
  "$@3", "$@4", "architecture_declarative_part",
  "..block_declaration_item..", "block_declaration_item",
  "signal_declaration", "component_declaration", "$@5",
  ".PORT__local_port_list.", "local_port_list", "...local_port_element..",
  "local_port_element", "architecture_statement_part",
  "..concurrent_statement..", "concurrent_statement",
  "component_instantiation_statement", "$@6", ".generic_map_aspect.",
  "generic_map_aspect", "generic_association_list",
  "...generic_association_element..", "generic_association_element",
  "formal_generic_name", "actual_generic_name", "generic_expression",
  "generic_relation", "generic_simple_expression", "$@7", ".sign.",
  "generic_term", "...generic_term..", "generic_factor", "generic_primary",
  "generic_aggregate", "$@8", "...generic_element_association..",
  "generic_element_association", ".generic_choices.", "generic_name",
  "generic_literal", ".port_map_aspect.", "port_map_aspect",
  "association_list", "...association_element..", "association_element",
  "formal_port_name", "actual_port_name", "name", "indexed_name",
  "slice_name", "expression", "relation", "simple_expression",
  ".sign.term..add_op__term..", "term", "factor", "primary", "aggregate",
  "type_convertion", ".SIGNAL.", ".local_port_mode.", ".mode.",
  "type_mark", ".BUS.", "identifier_list", "$@9", "...identifier..",
  "a_label", ".simple_name.", "simple_name", "Semicolon_ERR",
  "abstractlit", "RightParen_ERR", "END_ERR", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390
};
# endif

#define YYPACT_NINF -174

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-174)))

#define YYTABLE_NINF -154

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -16,    13,    54,    20,  -174,  -174,   -18,  -174,  -174,    39,
    -174,  -174,  -174,    41,    -2,   -21,    45,    -8,  -174,    41,
      81,    93,    61,    38,  -174,    26,  -174,  -174,    35,    81,
       6,  -174,    41,  -174,  -174,    78,    99,  -174,  -174,  -174,
    -174,    99,  -174,    78,    81,  -174,  -174,    97,  -174,    81,
      81,    81,    81,    98,  -174,    60,     5,  -174,    -6,  -174,
      35,  -174,     6,   -22,  -174,    81,    87,    78,  -174,  -174,
    -174,   105,  -174,  -174,  -174,  -174,  -174,  -174,  -174,  -174,
    -174,  -174,  -174,  -174,  -174,   112,  -174,  -174,  -174,  -174,
    -174,  -174,    -6,    38,    18,  -174,  -174,   106,    94,    96,
     118,  -174,   112,    41,    81,   120,  -174,  -174,    41,    -2,
      -6,  -174,  -174,    99,   -45,    36,  -174,    85,    81,  -174,
    -174,  -174,    43,   112,  -174,  -174,  -174,    96,  -174,  -174,
    -174,  -174,  -174,    67,  -174,  -174,  -174,    75,   133,    38,
      85,  -174,  -174,  -174,  -174,  -174,  -174,  -174,  -174,  -174,
    -174,  -174,  -174,    65,    50,  -174,     7,   100,    81,  -174,
    -174,   148,    71,    81,  -174,  -174,    99,  -174,    78,    81,
    -174,  -174,    36,  -174,   138,   151,  -174,    81,    81,   144,
    -174,    58,  -174,  -174,    99,  -174,   140,  -174,  -174,  -174,
      29,  -174,     7,    34,  -174,  -174,  -174,   149,    36,  -174,
      30,   155,    99,  -174,   143,  -174,   145,  -174,  -174,  -174,
    -174,  -174,   162,  -174,  -174,  -174,  -174,  -174,   161,  -174,
    -174,  -174,  -174,  -174,    -6,  -174,   138,  -174,  -174,    99,
      30,  -174,   158,    30,    30,    96,  -174,   112,  -174,  -174,
      99,    29,  -174,  -174,     3,    85,  -174,  -174,  -174,  -174
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     5,   155,     0,   154,     1,     0,
       2,     3,    35,     0,     6,     0,     0,    23,     7,     0,
       0,     0,     0,     0,    24,     0,   156,    10,     0,     0,
       0,   159,   153,    33,    15,     0,     0,    12,    26,    31,
     122,     0,    28,     0,     0,    37,   148,     0,   158,     0,
      11,     0,    27,     0,     4,     0,     0,   150,     0,     9,
       0,    25,     0,   128,    53,     0,     0,     0,    38,    39,
      40,   149,   145,   133,   136,   139,   144,   135,   138,   140,
     141,   142,   143,   134,   137,    17,    13,    29,   129,   131,
     132,   130,     0,     0,     0,    41,    43,     0,     0,     0,
       0,    18,    17,   153,     0,     0,    54,    55,     0,     6,
       0,   151,   157,     0,     0,    74,    14,   146,     0,    56,
     152,    57,    45,    17,    19,    22,    21,     0,    75,    76,
      16,    70,    71,     0,   147,    30,    34,    59,     0,     0,
     146,    20,    83,    92,    91,    72,    77,    79,    82,    80,
      81,    89,    90,     0,    93,    60,     0,     0,     0,    88,
      78,     0,     0,     0,    94,    51,     0,    48,     0,     0,
      42,    85,    74,    73,     0,     0,    58,     0,    47,     0,
      44,     0,    87,    67,     0,    63,     0,    66,    69,    68,
       0,    46,     0,   123,    88,    84,    61,    62,    74,   101,
       0,     0,     0,    97,     0,   100,   118,   105,   106,   103,
     109,   110,   111,   112,   114,   115,   116,   117,   104,    49,
     124,   126,   127,   125,     0,    86,     0,    65,   118,     0,
       0,    95,    96,     0,     0,     0,   108,    17,    64,   119,
       0,     0,    99,   113,     0,   146,   120,    98,   107,    50
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -174,  -174,  -174,  -174,    63,  -174,  -174,  -174,  -174,   109,
    -174,   -97,   -44,  -174,  -174,  -174,  -174,  -174,  -174,   113,
    -174,  -174,  -174,  -174,  -174,  -174,  -174,  -174,  -174,  -174,
    -174,  -174,   -15,  -174,  -174,  -174,  -174,  -174,  -174,  -174,
    -174,  -174,   -48,  -174,   -17,   -86,  -174,  -174,  -174,  -174,
    -174,  -174,  -174,  -174,  -174,  -174,  -174,   -14,  -174,  -174,
    -174,  -174,  -174,  -174,  -174,   -65,  -174,   -54,  -170,  -174,
    -174,  -173,  -174,  -174,  -174,   -52,  -174,  -174,  -174,  -174,
    -107,  -174,  -174,   -89,  -129,   -39,  -174,  -174,  -174,   -19,
      -1,   -27,  -117,   -40,   -50
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    14,    17,    18,    21,    36,    50,    37,
     116,   100,   101,   113,   127,    23,    24,    41,    52,    42,
      10,    13,    45,    55,    56,    68,    69,    70,   109,   139,
     166,   178,   167,    93,    94,   106,   107,   137,   154,   155,
     184,   197,   185,   186,   187,   188,   131,   132,   160,   133,
     145,   173,   146,   147,   148,   159,   181,   171,   172,   149,
     150,   163,   164,   202,   232,   203,   204,   205,   228,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
      43,   224,    92,    85,   135,    47,    57,    71,   108,     6,
     218,    27,   114,    49,    32
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
       7,    51,    38,   102,    53,   117,    65,    39,   165,    48,
     141,   158,    15,    44,     4,   125,   152,    54,    25,   104,
     206,   123,    59,    60,    61,    62,   140,   229,    97,   130,
     199,     7,  -121,  -121,   200,   200,    34,    72,    95,     5,
      12,    73,    74,   103,   105,   128,    20,   129,     1,   168,
      -8,   -36,    88,    89,     8,     5,     5,   240,    90,    11,
      66,     9,    29,   125,    48,   -32,    30,     5,   194,    16,
      75,   206,   142,   124,    19,    76,   126,   119,    91,    77,
      78,   -52,    79,    80,   118,   168,   182,   201,   201,   157,
    -153,   136,    35,     5,    22,    26,   112,    81,    28,   143,
     144,    31,     7,    33,    46,    48,    64,   121,   220,   221,
      58,    63,    82,    96,   222,    98,   249,    99,   244,   110,
     111,    67,    40,    40,   126,   112,   177,    83,    84,   179,
     115,   170,   151,   120,   223,   237,   176,   134,   156,   183,
     245,   195,   180,   -74,   196,   138,   153,   128,   161,   129,
     191,   192,   162,   174,   175,   169,   190,   193,   198,   226,
     230,   233,   231,  -102,     5,   234,   235,   -74,   241,    86,
     -74,   -74,   122,   189,   236,    87,   247,   219,   238,   242,
     225,   227,   243,     0,     0,     0,     0,     0,     0,   239,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     246,     0,     0,     0,   248,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   189
};

static const yytype_int16 yycheck[] =
{
       1,    41,    29,    92,    43,   102,     1,     1,     1,     6,
     127,   140,    13,    32,     1,    60,   133,    44,    19,     1,
     190,   110,    49,    50,    51,    52,   123,   200,    67,   115,
       1,    32,    26,    26,     5,     5,     1,    43,    65,    26,
       1,    47,    48,    93,    26,     9,     1,    11,    64,   156,
       5,    46,    74,    75,     0,    26,    26,   230,    80,    77,
      55,    41,     1,    60,     6,    26,     5,    26,    10,    71,
      76,   241,     5,   113,    95,    81,   121,   104,   100,    85,
      86,    63,    88,    89,   103,   192,   172,    58,    58,   139,
      77,   118,    57,    26,   102,    14,    29,   103,     5,    32,
      33,    63,   103,    77,    26,     6,    46,   108,    74,    75,
      13,    13,   118,    26,    80,    10,   245,     5,   235,    13,
      26,   116,   116,   116,   121,    29,   166,   133,   134,   168,
      12,   158,   133,    13,   100,   224,   163,    52,     5,     1,
     237,   181,   169,     5,   184,   102,    71,     9,    83,    11,
     177,   178,   102,     5,    83,    55,     5,    13,    18,    10,
       5,    18,   202,    18,    26,     3,     5,    29,    10,    60,
      32,    33,   109,   174,   218,    62,   241,   192,   226,   233,
     194,   198,   234,    -1,    -1,    -1,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     240,    -1,    -1,    -1,   244,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   226
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    64,   137,   138,     1,    26,   225,   226,     0,    41,
     156,    77,     1,   157,   139,   226,    71,   140,   141,    95,
       1,   142,   102,   151,   152,   226,    14,   227,     5,     1,
       5,    63,   230,    77,     1,    57,   143,   145,   227,     1,
     116,   153,   155,   216,   225,   158,    26,   221,     6,   229,
     144,   229,   154,   221,   227,   159,   160,   222,    13,   227,
     227,   227,   227,    13,    46,     1,    55,   116,   161,   162,
     163,   223,    43,    47,    48,    76,    81,    85,    86,    88,
      89,   103,   118,   133,   134,   219,   145,   155,    74,    75,
      80,   100,   218,   169,   170,   227,    26,   221,    10,     5,
     147,   148,   219,   230,     1,    26,   171,   172,   224,   164,
      13,    26,    29,   149,   228,    12,   146,   147,   225,   227,
      13,   226,   140,   219,   229,    60,   121,   150,     9,    11,
     181,   182,   183,   185,    52,   220,   227,   173,   102,   165,
     147,   228,     5,    32,    33,   186,   188,   189,   190,   195,
     196,   226,   228,    71,   174,   175,     5,   230,   220,   191,
     184,    83,   102,   197,   198,     1,   166,   168,   216,    55,
     227,   193,   194,   187,     5,    83,   227,   229,   167,   221,
     227,   192,   181,     1,   176,   178,   179,   180,   181,   226,
       5,   227,   227,    13,    10,   229,   229,   177,    18,     1,
       5,    58,   199,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   226,   168,
      74,    75,    80,   100,   217,   193,    10,   180,   204,   207,
       5,   229,   200,    18,     3,     5,   148,   219,   178,   229,
     207,    10,   203,   211,   228,   147,   229,   201,   229,   220
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   136,   137,   139,   138,   138,   140,   140,   142,   141,
     141,   143,   144,   144,   145,   145,   146,   147,   147,   148,
     149,   150,   150,   151,   151,   152,   152,   153,   154,   154,
     155,   155,   157,   158,   156,   156,   159,   160,   160,   161,
     161,   161,   162,   164,   163,   165,   165,   166,   167,   167,
     168,   168,   169,   170,   170,   171,   171,   173,   172,   174,
     174,   175,   176,   177,   177,   178,   178,   178,   179,   180,
     181,   182,   184,   183,   185,   185,   185,   186,   187,   188,
     189,   189,   189,   191,   190,   192,   192,   193,   194,   195,
     196,   196,   196,   197,   197,   198,   199,   200,   200,   201,
     201,   201,   202,   203,   204,   204,   204,   205,   206,   207,
     208,   209,   210,   210,   211,   212,   213,   213,   213,   214,
     215,   216,   216,   217,   217,   217,   217,   217,   218,   218,
     218,   218,   218,   219,   219,   219,   219,   219,   219,   219,
     219,   219,   219,   219,   219,   219,   220,   220,   222,   221,
     223,   223,   224,   225,   225,   226,   227,   228,   229,   230
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     9,     2,     0,     1,     0,     6,
       3,     2,     0,     3,     6,     1,     2,     0,     1,     3,
       3,     1,     1,     0,     1,     5,     3,     2,     0,     3,
       7,     1,     0,     0,    13,     2,     1,     0,     2,     1,
       1,     2,     7,     0,     8,     0,     5,     2,     0,     3,
       7,     1,     1,     0,     2,     1,     2,     0,     6,     0,
       1,     5,     2,     0,     3,     3,     1,     1,     1,     1,
       1,     1,     0,     4,     0,     1,     1,     1,     0,     1,
       1,     1,     1,     0,     5,     0,     3,     2,     0,     1,
       1,     1,     1,     0,     1,     5,     2,     0,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     4,     2,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     3,
       4,     0,     1,     0,     1,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     3,
       0,     3,     2,     0,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 225 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                freelomodel (MVL_CHDHED);
                mvl_fretab  (MVL_HSHTAB);
                }
#line 1756 "y.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 235 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                MVL_HSHTAB = mvl_initab ();
                MVL_SIMFLG = 0   ;      /* simple flag                  */
                MVL_NM1LST = NULL;      /* 1-st name liste              */
                MVL_NM2LST = NULL;      /* 2-nd name liste              */
                MVL_CHDPNT = NULL;      /* current child pointer        */
                MVL_CHDHED = NULL;      /* childs list                  */

                MVL_MODNAM = (yyvsp[-1].text);
                mvl_addtab (MVL_HSHTAB,MVL_MODNAM,MVL_MODNAM,MVL_MODDFN,
                            MVL_ROTDFN);
                }
#line 1773 "y.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 252 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                if (((yyvsp[-1].text) != NULL) && ((yyvsp[-1].text) != (yyvsp[-7].text)))
                  mvl_error (1, (yyvsp[-1].text));
                mvl_addtab (MVL_HSHTAB,MVL_MODNAM,MVL_MODNAM,MVL_CCNDFN,
                            MVL_CONCNT);
                MVL_CONCNT = 0;
                }
#line 1785 "y.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 261 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { mvl_error (2, NULL); }
#line 1791 "y.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 271 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {                 /* NULL means we're in the entity declaration */
               if (!MVL_CHDHED) {
                  MVL_LOFPNT->USER=addptype(MVL_LOFPNT->USER,LOGEN,NULL);
                  MVL_PTPPNT=MVL_LOFPNT->USER;
               } else {
                  MVL_CHDPNT->USER=addptype(MVL_LOFPNT->USER,LOGEN,NULL);
                  MVL_PTPPNT=MVL_CHDPNT->USER;
               }
            }
#line 1805 "y.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 308 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
             struct chain *l;
                
                for (l=MVL_NM1LST;l;l=l->NEXT) {
                   MVL_PTPPNT->DATA=duplogen(&MVL_LOGEN,
                                             MVL_PTPPNT->DATA,l->DATA);
                }
                switch ((yyvsp[-2].valu)) {
                   case MVL_ARGDFN:
                   {
                      logen_list *gen = (logen_list *)MVL_PTPPNT->DATA;
                      gen->TYPE=GENTYPE_ARG;
                   }
                   break;
                   case MVL_BITDFN:
                   {
                      logen_list *gen = (logen_list *)MVL_PTPPNT->DATA;
                      gen->TYPE=GENTYPE_BIT;
                   }
                   break;
                }

                MVL_LOGEN.TYPE=GENTYPE_EMPTY;
                freechain (MVL_NM1LST);
                MVL_NM1LST = NULL;
             }
#line 1836 "y.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 344 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                (yyval.name).LEFT  = -1;
                (yyval.name).RIGHT = -1;
                (yyval.name).ERR_FLG = 0;
                }
#line 1846 "y.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 350 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.name) = (yyvsp[0].name); }
#line 1852 "y.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 357 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.name) = (yyvsp[-1].name); }
#line 1858 "y.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 364 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                (yyval.name).LEFT  = (yyvsp[-2].valu);
                (yyval.name).RIGHT = (yyvsp[0].valu);

                if ((((yyvsp[-2].valu) > (yyvsp[0].valu)) && ((yyvsp[-1].valu) == MVL_UPTDFN)) ||
                    (((yyvsp[-2].valu) < (yyvsp[0].valu)) && ((yyvsp[-1].valu) == MVL_DWTDFN)))
                  {
                  mvl_error (32, NULL);
                  (yyval.name).ERR_FLG = 1;
                  }
                else
                  (yyval.name).ERR_FLG = 0;
                }
#line 1876 "y.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 381 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_UPTDFN; }
#line 1882 "y.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 383 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_DWTDFN; }
#line 1888 "y.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 400 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { mvl_error (3, NULL); }
#line 1894 "y.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 423 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                struct losig *losig_pnt;
                long           sig_width;
                long           sig_conf;
                char         *sig_name;
                struct chain *sig_list;
                long           local_err;

                local_err = (yyvsp[-1].name).ERR_FLG;
                if ( ((yyvsp[-1].name).LEFT == -1) && (((yyvsp[-2].valu) == MVL_BTVDFN) ||
                                         ((yyvsp[-2].valu) == MVL_MXVDFN) ||
                                         ((yyvsp[-2].valu) == MVL_WRVDFN)))
                  {
                  mvl_error (33, NULL);
                  }

                if ((yyvsp[-1].name).LEFT <= (yyvsp[-1].name).RIGHT)
                  sig_width = (yyvsp[-1].name).RIGHT - (yyvsp[-1].name).LEFT  + 1;
                else
                  sig_width = (yyvsp[-1].name).LEFT  - (yyvsp[-1].name).RIGHT + 1;

                sig_conf   = (yyvsp[-3].valu) + (yyvsp[-2].valu) + (yyvsp[0].valu);
                MVL_NM1LST = reverse (MVL_NM1LST);
                sig_list   = MVL_NM1LST;
                while ((sig_list != NULL) && (local_err == 0))
                  {
                  sig_name = (char *)sig_list->DATA;

                  if (mvl_chktab (MVL_HSHTAB,sig_name,MVL_MODNAM,
                                  MVL_SIGDFN) != 0)
                    mvl_error (4, sig_name);
                  else
                    {
                    switch (sig_conf)
                      {
                      case (MVL_ICNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_ICNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','0',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'I',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_OCNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_OCNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','0',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'O',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_OCNDFN + MVL_MUXDFN + MVL_BUSDFN) :
                      case (MVL_OCNDFN + MVL_MXVDFN + MVL_BUSDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','M',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'Z',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_OCNDFN + MVL_WORDFN + MVL_BUSDFN) :
                      case (MVL_OCNDFN + MVL_WRVDFN + MVL_BUSDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','W',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'Z',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_BCNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_BCNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','0',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'B',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_BCNDFN + MVL_MUXDFN + MVL_BUSDFN) :
                      case (MVL_BCNDFN + MVL_MXVDFN + MVL_BUSDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','M',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'T',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_BCNDFN + MVL_WORDFN + MVL_BUSDFN) :
                      case (MVL_BCNDFN + MVL_WRVDFN + MVL_BUSDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','W',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'T',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_XCNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_XCNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        losig_pnt = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,'E','0',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        mvl_addlocon (MVL_LOFPNT,losig_pnt,'X',
                                                  sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;
                      default :
                        mvl_error (5, sig_name);
                        local_err = 1;
                        break;
                      }

                    if (local_err == 0)
                      {
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_PNTDFN,
                                  (long)losig_pnt);
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_SIGDFN,
                                  sig_conf);
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_LFTDFN,
                                  (yyvsp[-1].name).LEFT);
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_RGTDFN,
                                  (yyvsp[-1].name).RIGHT);
                      MVL_CONCNT += sig_width;
                      MVL_SIGIDX += sig_width;
                      }
                    }

                  sig_list = sig_list->NEXT;
                  }
                freechain (MVL_NM1LST);
                MVL_NM1LST = NULL;
                }
#line 2023 "y.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 548 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {

                /* ###----------------------------------------------### */
                /*   The following 3 lines reject tokens until the      */
                /* sync. token ('Semicolon') is found                   */
                /* ###----------------------------------------------### */

                do
                  yychar = yylex ();
                while ((yychar != Semicolon) && (yychar != 0));
                yyerrok;

                mvl_error (6, NULL);
                }
#line 2042 "y.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 566 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                if (!strcmp (IN_LO, "vbe"))
                  YYACCEPT;
                }
#line 2051 "y.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 574 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                if ((yyvsp[-1].text) != MVL_MODNAM)
                  mvl_error (1, (yyvsp[-1].text));
                }
#line 2060 "y.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 584 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                if (((yyvsp[-1].text) != NULL) && ((yyvsp[-1].text) != (yyvsp[-10].text)))
                  mvl_error (7, (yyvsp[-1].text));
                }
#line 2069 "y.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 590 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { mvl_error (8, NULL); }
#line 2075 "y.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 608 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { mvl_error (9, NULL); }
#line 2081 "y.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 619 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                struct losig *losig_pnt;
                long           sig_width;
                long           sig_conf;
                char         *sig_name;
                struct chain *sig_list;
                long           local_err;

                local_err = (yyvsp[-2].name).ERR_FLG;
                if (((yyvsp[-2].name).LEFT==-1) && (((yyvsp[-3].valu)==MVL_BTVDFN) || ((yyvsp[-3].valu)==MVL_RGVDFN)))
                  {
                  mvl_error (33, NULL);
                  }
                if ((yyvsp[-2].name).LEFT <= (yyvsp[-2].name).RIGHT)
                  sig_width = (yyvsp[-2].name).RIGHT - (yyvsp[-2].name).LEFT  + 1;
                else
                  sig_width = (yyvsp[-2].name).LEFT  - (yyvsp[-2].name).RIGHT + 1;

                sig_conf   = (yyvsp[-3].valu) + (yyvsp[-1].valu);
                MVL_NM1LST = reverse (MVL_NM1LST);
                sig_list   = MVL_NM1LST;
                while ((sig_list != NULL) && (local_err == 0))
                  {
                  sig_name = (char *)sig_list->DATA;

                  if (mvl_chktab (MVL_HSHTAB,sig_name,MVL_MODNAM,
                                  MVL_SIGDFN) != 0)
                    mvl_error (10, sig_name);
                  else
                    {
                    switch (sig_conf)
                      {
                      case (MVL_BITDFN + MVL_NORDFN):
                      case (MVL_BTVDFN + MVL_NORDFN):
                        losig_pnt = mvl_addlosig(MVL_LOFPNT,MVL_SIGIDX,'I','0',
                                                 sig_name,(yyvsp[-2].name).LEFT,(yyvsp[-2].name).RIGHT);
                        break;

                      case (MVL_MUXDFN + MVL_BUSDFN):
                      case (MVL_MXVDFN + MVL_BUSDFN):
                        losig_pnt = mvl_addlosig(MVL_LOFPNT,MVL_SIGIDX,'I','M',
                                                 sig_name,(yyvsp[-2].name).LEFT,(yyvsp[-2].name).RIGHT);
                        break;

                      case (MVL_WORDFN + MVL_BUSDFN):
                      case (MVL_WRVDFN + MVL_BUSDFN):
                        losig_pnt = mvl_addlosig(MVL_LOFPNT,MVL_SIGIDX,'I','W',
                                                 sig_name,(yyvsp[-2].name).LEFT,(yyvsp[-2].name).RIGHT);
                        break;

                      default:
                        mvl_error (11, sig_name);
                        local_err = 1;
                        break;
                      }

                    if (local_err == 0)
                      {
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_PNTDFN,
                                  (long)losig_pnt);
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_SIGDFN,
                                  sig_conf);
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_LFTDFN,
                                  (yyvsp[-2].name).LEFT);
                      mvl_addtab (MVL_HSHTAB,sig_name,MVL_MODNAM,MVL_RGTDFN,
                                  (yyvsp[-2].name).RIGHT);
                      MVL_SIGIDX += sig_width;
                      }
                    }

                  sig_list = sig_list->NEXT;
                  }
                freechain (MVL_NM1LST);
                MVL_NM1LST = NULL;
                }
#line 2161 "y.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 699 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                MVL_CHDNAM = (yyvsp[0].text);

                if (mvl_chktab (MVL_HSHTAB,MVL_CHDNAM,MVL_MODNAM,MVL_MODDFN) != 0)
                  {
                  mvl_error (12, MVL_CHDNAM);
                  MVL_CHDPNT = NULL;
                  }
                else
                  {
                  MVL_CHDHED = addlomodel (MVL_CHDHED,MVL_CHDNAM);

                  MVL_CHDPNT = MVL_CHDHED;
                  mvl_addtab (MVL_HSHTAB,MVL_CHDNAM,MVL_MODNAM,MVL_MODDFN,MVL_CHDDFN);
                  }
                }
#line 2182 "y.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 720 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                if (MVL_CHDPNT != NULL)
                  {
                  mvl_addtab (MVL_HSHTAB,(yyvsp[-6].text),MVL_MODNAM,MVL_CCNDFN,MVL_CONCNT);
                  MVL_LOFPNT->MODELCHAIN = addchain (MVL_LOFPNT->MODELCHAIN,(yyvsp[-6].text));
                  }
                MVL_CONCNT = 0;
                }
#line 2195 "y.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 759 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                long           sig_width;
                long           sig_conf;
                char         *sig_name;
                struct chain *sig_list;
                long           local_err = 0;

                if (((yyvsp[-1].name).ERR_FLG != 0) || (MVL_CHDPNT == NULL))
                  local_err = 1;

                if (((yyvsp[-1].name).LEFT == -1) && (((yyvsp[-2].valu) == MVL_BTVDFN) ||
                                        ((yyvsp[-2].valu) == MVL_MXVDFN) ||
                                        ((yyvsp[-2].valu) == MVL_WRVDFN))  )
                  {
                  mvl_error (33, NULL);
                  }
                if ((yyvsp[-1].name).LEFT <= (yyvsp[-1].name).RIGHT)
                  sig_width = (yyvsp[-1].name).RIGHT - (yyvsp[-1].name).LEFT  + 1;
                else
                  sig_width = (yyvsp[-1].name).LEFT  - (yyvsp[-1].name).RIGHT + 1;

                sig_conf   = (yyvsp[-3].valu) + (yyvsp[-2].valu) + (yyvsp[0].valu);
                MVL_NM1LST = reverse (MVL_NM1LST);
                sig_list   = MVL_NM1LST;
                while ((sig_list != NULL) && (local_err == 0))
                  {
                  sig_name = (char *)sig_list->DATA;
                  if (mvl_chktab (MVL_HSHTAB,sig_name,MVL_CHDNAM,
                                  MVL_SIGDFN) != 0)
                    mvl_error (4, sig_name);
                  else
                    {
                    switch (sig_conf)
                      {
                      case (MVL_ICNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_ICNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'I', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_OCNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_OCNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'O', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_OCNDFN + MVL_MUXDFN + MVL_BUSDFN) :
                      case (MVL_OCNDFN + MVL_MXVDFN + MVL_BUSDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'Z', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_OCNDFN + MVL_WORDFN + MVL_BUSDFN) :
                      case (MVL_OCNDFN + MVL_WRVDFN + MVL_BUSDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'Z', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_BCNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_BCNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'B', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_BCNDFN + MVL_MUXDFN + MVL_BUSDFN) :
                      case (MVL_BCNDFN + MVL_MXVDFN + MVL_BUSDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'T', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_BCNDFN + MVL_WORDFN + MVL_BUSDFN) :
                      case (MVL_BCNDFN + MVL_WRVDFN + MVL_BUSDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'T', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      case (MVL_XCNDFN + MVL_BITDFN + MVL_NORDFN) :
                      case (MVL_XCNDFN + MVL_BTVDFN + MVL_NORDFN) :
                        mvl_addlocon (MVL_CHDPNT,NULL,'X', sig_name,(yyvsp[-1].name).LEFT,(yyvsp[-1].name).RIGHT);
                        break;

                      default :
                        mvl_error (5, sig_name);
                        local_err = 1;
                        break;
                      }

                    if (local_err == 0)
                      {
                      mvl_addtab (MVL_HSHTAB,MVL_CONCNT,MVL_CHDNAM,MVL_PNTDFN,
                                  sig_name);
                      mvl_addtab (MVL_HSHTAB,sig_name,  MVL_CHDNAM,MVL_SIGDFN,
                                  sig_conf);
                      mvl_addtab (MVL_HSHTAB,sig_name,  MVL_CHDNAM,MVL_RNGDFN,
                                  MVL_CONCNT);
                      mvl_addtab (MVL_HSHTAB,sig_name,  MVL_CHDNAM,MVL_LFTDFN,
                                  (yyvsp[-1].name).LEFT);
                      mvl_addtab (MVL_HSHTAB,sig_name,  MVL_CHDNAM,MVL_RGTDFN,
                                  (yyvsp[-1].name).RIGHT);
                      MVL_CONCNT += sig_width;
                      }
                    }
                  sig_list = sig_list->NEXT;
                  }
                freechain (MVL_NM1LST);
                MVL_NM1LST = NULL;
                }
#line 2300 "y.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 860 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {

                /* ###----------------------------------------------### */
                /*   The following 3 lines reject tokens until the      */
                /* sync. token ('Semicolon') is found                   */
                /* ###----------------------------------------------### */

                do
                  yychar = yylex ();
                while ((yychar != Semicolon) && (yychar != 0));
                yyerrok;

                mvl_error (6, NULL);
                }
#line 2319 "y.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 890 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { mvl_error (18, NULL); }
#line 2325 "y.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 896 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                long con_count;
                long local_err = 0;

                MVL_CONRNK = 0;
                MVL_CHDNAM = (yyvsp[0].text);
                MVL_LOCNAM = (yyvsp[-1].text);

                if (mvl_chktab (MVL_HSHTAB,(yyvsp[-1].text),MVL_MODNAM,MVL_LBLDFN) != 0)
                  {
                  mvl_error (13, (yyvsp[-1].text));
                  local_err = 1;
                  }

                if (mvl_chktab (MVL_HSHTAB,(yyvsp[0].text),MVL_MODNAM,
                                MVL_MODDFN) != MVL_CHDDFN)
                  {
                  mvl_error (14, (yyvsp[0].text));
                  local_err = 1;
                  }

                if (local_err == 0)
                  {
                  mvl_addtab (MVL_HSHTAB,(yyvsp[-1].text),MVL_MODNAM,MVL_LBLDFN,1);
                  con_count  = mvl_chktab (MVL_HSHTAB,(yyvsp[0].text),MVL_MODNAM,MVL_CCNDFN);
                  MVL_NM1LST = NULL;
                  while (con_count != 0)
                    {
                    MVL_NM1LST = addchain (MVL_NM1LST,NULL);
                    con_count--;
                    }
                  MVL_CHDPNT = MVL_CHDHED;
                  while (MVL_CHDPNT != NULL)
                    {
                    if (MVL_CHDPNT->NAME == (yyvsp[0].text))
                      break;
                    MVL_CHDPNT = MVL_CHDPNT->NEXT;
                    }
                  }
                else
                  MVL_CHDPNT = NULL;

                }
#line 2373 "y.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 942 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                struct loins *loins_pnt    ;
                struct locon *locon_pnt    ;
                struct chain *chain_pnt    ;
                char          tampon [256] ;

                if (MVL_CHDPNT != NULL)
                  {
                  MVL_NM1LST = reverse (MVL_NM1LST);

                  chain_pnt  = MVL_NM1LST;
                  locon_pnt  = MVL_CHDPNT->LOCON;

                  while (chain_pnt != NULL)
                    {
                    if (chain_pnt->DATA == NULL)
                      {
                      MVL_SIGIDX++;
                      sprintf(tampon,"%s:%s.%s",MVL_CHDNAM,(yyvsp[-5].text),locon_pnt->NAME);
                      chain_pnt->DATA = mvl_addlosig (MVL_LOFPNT,MVL_SIGIDX,
                                                      'I','0',tampon,-1,-1);
                      }
                    chain_pnt = chain_pnt->NEXT;
                    locon_pnt = locon_pnt->NEXT;
                    }

                  if (MVL_ERRFLG == 0) {
                    loins_pnt = addloins (MVL_LOFPNT, (yyvsp[-5].text)  , MVL_CHDPNT,
                                          MVL_NM1LST );
                     if (MVL_CHDPNT->USER) {
                        if (!MVL_PTPPNT)
                           MVL_PTPPNT = addptype(NULL,LOGEN,NULL);  
                        loins_pnt->USER=MVL_PTPPNT;
                        MVL_PTPPNT->DATA
                                = chklogen(loins_pnt->USER->DATA,
                                             MVL_CHDPNT->USER->DATA,
                                             MVL_CHDNAM, loins_pnt->INSNAME);
                     } else {
                        if (MVL_PTPPNT) {
                           fprintf(stderr,"No generic for model %s, NULLed !\n",
                                MVL_CHDPNT->NAME);
                           loins_pnt->USER=NULL;
                        }
                     }

                    }
                  }

                freechain (MVL_NM1LST);
                MVL_NM1LST = NULL;
                MVL_SIMFLG = MVL_UKNDFN;
                }
#line 2430 "y.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 1002 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
             MVL_PTPPNT = NULL;
          }
#line 2438 "y.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1014 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
             MVL_PTPPNT = addptype(NULL,LOGEN,MVL_GENPNT);  
             MVL_GENPNT = NULL;
          }
#line 2447 "y.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1036 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
             MVL_GENPNT = duplogen(&MVL_LOGEN,MVL_GENPNT,(yyvsp[-2].text));
             MVL_LOGEN.TYPE=GENTYPE_EMPTY;
          }
#line 2456 "y.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 1041 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
             MVL_GENPNT = duplogen(&MVL_LOGEN,MVL_GENPNT,NULL);
             MVL_LOGEN.TYPE=GENTYPE_EMPTY;
          }
#line 2465 "y.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1067 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                   if ((yyvsp[-1].flag)) {
                      if (MVL_LOGEN.TYPE!=GENTYPE_VAL) {
                         fputs("Don't know how to change Identifier sign\n",
                               stderr);
                      } else
                         MVL_LOGEN.VALUE.VAL = -MVL_LOGEN.VALUE.VAL;
                   }
                }
#line 2479 "y.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1080 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.flag) = 0; }
#line 2485 "y.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1081 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.flag) = 0; }
#line 2491 "y.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1082 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.flag) = 1; }
#line 2497 "y.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1102 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
             MVL_LOGEN.VALUE.TEXT=namealloc((yyvsp[0].text));
             MVL_LOGEN.TYPE=GENTYPE_TEXT;
          }
#line 2506 "y.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1108 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
             MVL_LOGEN.VALUE.LIST = (logen_list *)reverse(MVL_GENLST->DATA);
             MVL_LOGEN.TYPE = GENTYPE_LIST;
             MVL_GENLST = delchain(MVL_GENLST, MVL_GENLST);
          }
#line 2516 "y.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1117 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
             MVL_GENLST = addchain(MVL_GENLST, NULL);
          }
#line 2524 "y.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1135 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
             MVL_GENLST->DATA = duplogen (&MVL_LOGEN,
                                ((logen_list *)MVL_GENLST->DATA), NULL);
             MVL_LOGEN.TYPE = GENTYPE_EMPTY;
          }
#line 2534 "y.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1153 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[0].text); }
#line 2540 "y.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1158 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
             MVL_LOGEN.VALUE.VAL = (yyvsp[0].valu);
             if (base==16)
                MVL_LOGEN.TYPE = GENTYPE_HEX ;
             else
                MVL_LOGEN.TYPE = GENTYPE_VAL ;
          }
#line 2552 "y.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1166 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
             MVL_LOGEN.VALUE.TEXT = strdup((yyvsp[0].text));
             MVL_LOGEN.TYPE = GENTYPE_TEXT;
          }
#line 2561 "y.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1171 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
             MVL_LOGEN.VALUE.CHAR = (yyvsp[0].text)[1];
             MVL_LOGEN.TYPE = GENTYPE_BIT;
          }
#line 2570 "y.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1210 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                long           sig_width;
                long           con_pos;
                struct chain *sig_list1;
                struct chain *sig_list2;
                long           local_err = 0;

                if (MVL_CHDPNT == NULL)
                  local_err = 1;
                sig_list1 = MVL_NM1LST;

                if (MVL_SIMFLG == MVL_IMPDFN)
                  sig_list1 = MVL_NM2LST;
                MVL_SIMFLG = MVL_EXPDFN;

                if ((yyvsp[-2].name).LEFT <= (yyvsp[-2].name).RIGHT)
                  sig_width = (yyvsp[-2].name).RIGHT - (yyvsp[-2].name).LEFT + 1;
                else
                  sig_width = (yyvsp[-2].name).LEFT - (yyvsp[-2].name).RIGHT + 1;

                if (local_err == 0)
                  {
                  if (sig_width != (yyvsp[0].expr).WIDTH)
                    mvl_error (38, NULL);
                  else
                    {
                    if (MVL_ERRFLG == 0)
                      {
                      con_pos = mvl_chktab (MVL_HSHTAB, (yyvsp[-2].name).NAME, MVL_CHDNAM,
                                            MVL_RNGDFN);
                      while (con_pos != 0)
                        {
                        sig_list1 = sig_list1->NEXT;
                        con_pos--;
                        }
                      sig_list2 = (yyvsp[0].expr).LIST;
                      while (sig_list2 != NULL)
                        {
                        if (sig_list1->DATA != NULL)
                          {
                          mvl_error (41, (yyvsp[-2].name).NAME);
                          break;
                          }
                        sig_list1->DATA = sig_list2->DATA;
                        sig_list2       = sig_list2->NEXT;
                        sig_list1       = sig_list1->NEXT;
                        }
                      }
                    }
                  }
                freechain ((yyvsp[0].expr).LIST);
                }
#line 2627 "y.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1263 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                struct chain *sig_list1 ;
                char         *prt_name  ;
                long           prt_width ;
                long           left_bnd  ;
                long           right_bnd ;
                long           local_err = 0;
                long           i         ;

                if (MVL_CHDPNT == NULL)
                  local_err = 1;

                if (MVL_SIMFLG == MVL_UKNDFN)
                  {
                  MVL_SIMFLG = MVL_IMPDFN;
                  MVL_NM2LST = MVL_NM1LST;
                  }
                if (MVL_SIMFLG != MVL_IMPDFN)
                  {
                  mvl_error (15, NULL);
                  local_err = 1;
                  }

                prt_name  = (char *) mvl_chktab (MVL_HSHTAB,MVL_CONRNK,
                                                 MVL_CHDNAM,MVL_PNTDFN);
                if (prt_name == NULL)
                  {
                  local_err = 1;
                  mvl_error (76, MVL_LOCNAM);
                  }

                right_bnd = mvl_chktab (MVL_HSHTAB,prt_name,MVL_CHDNAM,
                                        MVL_LFTDFN);
                left_bnd  = mvl_chktab (MVL_HSHTAB,prt_name,MVL_CHDNAM,
                                        MVL_RGTDFN);

                if (left_bnd <= right_bnd)
                  prt_width = right_bnd - left_bnd  + 1;
                else
                  prt_width = left_bnd  - right_bnd + 1;

                if (local_err == 0)
                  {
                  if (prt_width != (yyvsp[0].expr).WIDTH)
                    {
                    mvl_error (38, NULL);
                    for (i=0 ; i<prt_width ; i++)
                      MVL_NM2LST = MVL_NM2LST->NEXT;
                    }
                  else
                    {
                    sig_list1 = (yyvsp[0].expr).LIST;
                    while (sig_list1 != NULL)
                      {
                      MVL_NM2LST->DATA = sig_list1->DATA;
                      sig_list1        = sig_list1->NEXT;
                      MVL_NM2LST       = MVL_NM2LST->NEXT;
                      }
                    }
                  MVL_CONRNK += prt_width;
                  }
                freechain ((yyvsp[0].expr).LIST);
                }
#line 2695 "y.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1327 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {

                /* ###----------------------------------------------### */
                /*   The following 3 lines reject tokens until the      */
                /* sync. token ('Comma') is found                       */
                /* ###----------------------------------------------### */

                do
                  yychar = yylex ();
                while ((yychar != Comma) && (yychar != 0));
                yyerrok;

                MVL_CONRNK++;
                mvl_error (31, NULL);
                }
#line 2715 "y.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1346 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                if (MVL_CHDPNT != NULL)
                  {
                  if (mvl_chktab(MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_CHDNAM,MVL_SIGDFN) != 0)
                    {
                    (yyval.name).LEFT  = mvl_chktab (MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_CHDNAM,
                                           MVL_LFTDFN);
                    (yyval.name).RIGHT = mvl_chktab (MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_CHDNAM,
                                           MVL_RGTDFN);
                    }
                  else
                    {
                    mvl_error (16, (yyvsp[0].name).NAME);
                    (yyval.name) = (yyvsp[0].name);
                    }
                  }
                else
                  (yyval.name) = (yyvsp[0].name);
                }
#line 2739 "y.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1369 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2745 "y.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1374 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                (yyval.name).NAME  = (yyvsp[0].text);
                (yyval.name).LEFT  = -1;
                (yyval.name).RIGHT = -1;
                }
#line 2755 "y.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1380 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.name) = (yyvsp[0].name); }
#line 2761 "y.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1382 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.name) = (yyvsp[0].name); }
#line 2767 "y.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1390 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                (yyval.name).NAME  = (yyvsp[-3].text);
                (yyval.name).LEFT  = (yyvsp[-1].valu);
                (yyval.name).RIGHT = (yyvsp[-1].valu);
                }
#line 2777 "y.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1400 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                (yyval.name).NAME  = (yyvsp[-1].text);
                (yyval.name).LEFT  = (yyvsp[0].name).LEFT;
                (yyval.name).RIGHT = (yyvsp[0].name).RIGHT;
                }
#line 2787 "y.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1410 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2793 "y.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1415 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2799 "y.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1420 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2805 "y.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1425 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2811 "y.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1429 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                struct chain *list1;

                list1 = (yyvsp[-2].expr).LIST;
                while (list1->NEXT != NULL)
                  list1 = list1->NEXT;

                list1->NEXT = (yyvsp[0].expr).LIST;
                (yyval.expr).LIST     = (yyvsp[-2].expr).LIST;
                (yyval.expr).WIDTH    = (yyvsp[-2].expr).WIDTH + (yyvsp[0].expr).WIDTH;
                }
#line 2827 "y.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1445 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2833 "y.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1451 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2839 "y.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1456 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2845 "y.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1458 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2851 "y.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1460 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                mvl_expr      expr;
                struct losig *losig_pnt;
                long           i;
                long           left;
                long           right;
                long           left_bnd;
                long           right_bnd;
                long           sig_width;
                long           rev_flg;
                long           in_bound;
                long           out_bound;

                if (mvl_chktab (MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_MODNAM,MVL_SIGDFN) != 0)
                  {
                  left_bnd  = mvl_chktab (MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_MODNAM,
                                          MVL_LFTDFN);
                  right_bnd = mvl_chktab (MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_MODNAM,
                                          MVL_RGTDFN);

                  if ((yyvsp[0].name).LEFT == -1)
                    {
                    left  = left_bnd;
                    right = right_bnd;
                    }
                  else
                    {
                    left  = (yyvsp[0].name).LEFT;
                    right = (yyvsp[0].name).RIGHT;
                    }

                  if (left_bnd <= right_bnd)
                    {
                    sig_width = right_bnd - left_bnd + 1;
                    if (left <= right)
                      {
                      expr.WIDTH   = right - left + 1;
                      rev_flg    = 0;
                      in_bound   = right_bnd - right;
                      out_bound  = right_bnd - left;
                      if ((left < left_bnd) || (right > right_bnd))
                        mvl_error (36, (yyvsp[0].name).NAME);
                      }
                    else
                      {
                      expr.WIDTH   = left - right + 1;
                      rev_flg    = 1;
                      in_bound   = right_bnd - left;
                      out_bound  = right_bnd - right;
                      if ((left > right_bnd) || (right < left_bnd))
                        mvl_error (36, (yyvsp[0].name).NAME);
                      }
                    }
                  else
                    {
                    sig_width = left_bnd - right_bnd + 1;
                    if (left <= right)
                      {
                      expr.WIDTH   = right - left + 1;
                      rev_flg    = 1;
                      in_bound   = left  - right_bnd;
                      out_bound  = right - right_bnd;
                      if ((left < right_bnd) || (right > left_bnd))
                        mvl_error (36, (yyvsp[0].name).NAME);
                      }
                    else
                      {
                      expr.WIDTH   = left - right + 1;
                      rev_flg    = 0;
                      in_bound   = right - right_bnd;
                      out_bound  = left  - right_bnd;
                      if ((left > left_bnd) || (right < right_bnd))
                        mvl_error (36, (yyvsp[0].name).NAME);
                      }
                    }

                  losig_pnt = (struct losig *)
                              mvl_chktab (MVL_HSHTAB,(yyvsp[0].name).NAME,MVL_MODNAM,
                                          MVL_PNTDFN);
                  expr.LIST = NULL;
                  for (i=0 ; i<sig_width ; i++)
                    {
                    if (i >= in_bound)
                      expr.LIST = addchain (expr.LIST,losig_pnt);
                    if (i >= out_bound)
                      break;
                    losig_pnt = losig_pnt->NEXT;
                    }
                  if (rev_flg == 1)
                    expr.LIST = reverse (expr.LIST);
                  }
                else
                  {
                  mvl_error (17, (yyvsp[0].name).NAME);
                  expr.WIDTH = 1;
                  expr.LIST  = addchain (NULL,NULL);
                  }
                (yyval.expr) = expr;
                }
#line 2955 "y.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1565 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 2961 "y.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1573 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 2967 "y.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1584 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_ICNDFN; }
#line 2973 "y.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1586 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_ICNDFN; }
#line 2979 "y.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1588 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_OCNDFN; }
#line 2985 "y.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1590 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_BCNDFN; }
#line 2991 "y.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1592 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                mvl_warning (2, NULL);
                (yyval.valu) = MVL_XCNDFN;
                }
#line 3000 "y.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1600 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_ICNDFN; }
#line 3006 "y.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1602 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_ICNDFN; }
#line 3012 "y.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1604 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_OCNDFN; }
#line 3018 "y.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1606 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_BCNDFN; }
#line 3024 "y.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1608 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_XCNDFN; }
#line 3030 "y.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1613 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_BITDFN; }
#line 3036 "y.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1615 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_WORDFN; }
#line 3042 "y.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1617 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_MUXDFN; }
#line 3048 "y.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1619 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_BTVDFN; }
#line 3054 "y.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1621 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_WRVDFN; }
#line 3060 "y.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1623 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_MXVDFN; }
#line 3066 "y.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1625 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_NATDFN; }
#line 3072 "y.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1627 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_NATDFN; }
#line 3078 "y.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1629 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_NAVDFN; }
#line 3084 "y.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1631 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_NATDFN; }
#line 3090 "y.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1633 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_STRDFN; }
#line 3096 "y.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1635 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_LSTDFN; }
#line 3102 "y.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1637 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_ARGDFN; }
#line 3108 "y.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1642 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_NORDFN; }
#line 3114 "y.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1644 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.valu) = MVL_BUSDFN; }
#line 3120 "y.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1649 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                  MVL_NM1LST = addchain (MVL_NM1LST,(yyvsp[0].text));
                }
#line 3128 "y.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1660 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                  MVL_NM1LST = addchain (MVL_NM1LST,(yyvsp[0].text));
                }
#line 3136 "y.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1668 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[-1].text); }
#line 3142 "y.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1673 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.text) = NULL; }
#line 3148 "y.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1675 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[0].text); }
#line 3154 "y.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1680 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[0].text); }
#line 3160 "y.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1685 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { yyerrok; }
#line 3166 "y.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1690 "./mvl_scomp_y.y" /* yacc.c:1646  */
    {
                  char *absend, *absbase;

                  base = strtoul ((yyvsp[0].text), &absbase, 10);
                  if (*absbase=='\0')
                     (yyval.valu) = base;
                  else
                     (yyval.valu) = strtoul(absbase+1, &absend, base);
                }
#line 3180 "y.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1703 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { yyerrok; }
#line 3186 "y.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1708 "./mvl_scomp_y.y" /* yacc.c:1646  */
    { yyerrok; }
#line 3192 "y.tab.c" /* yacc.c:1646  */
    break;


#line 3196 "y.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1711 "./mvl_scomp_y.y" /* yacc.c:1906  */

